Bug 208359 - spurious AAAA DNS query hurts performance and is anti-social
spurious AAAA DNS query hurts performance and is anti-social
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: exim (Show other bugs)
8
All Linux
medium Severity medium
: ---
: ---
Assigned To: David Woodhouse
Fedora Extras Quality Assurance
bzcl34nup
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-09-27 20:19 EDT by Russell Coker
Modified: 2009-01-09 01:59 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-09 01:59:09 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Russell Coker 2006-09-27 20:19:13 EDT
I am currently benchmarking mail relay systems with a soon to be released 
version of my Postal benchmark and found a performance related bug in 
exim-4.63-4.fc6.

IP exim.35992 > DNS.domain:  43702+ MX? a0.example.com. (32)
IP exim.35992 > DNS.domain:  7866+ AAAA? mail.a0.example.com. (37)
IP exim.35992 > DNS.domain:  31399+ A? mail.a0.example.com. (37)

I noticed that often DNS queries are a bottleneck.  Exim does the above 
queries for an email addressed to user@a0.example.com, however my machine has 
IPv6 disabled (the ipv6 kernel module is not loaded) so it is impossible for 
Exim to do anything with the AAAA record.  I believe that Exim should be able 
to work this out and refrain from doing the extra query.

When an entry in /etc/aliases expands to 254 users in different domains 
Postfix will do ~500 DNS queries and Exim will do ~750.  This will give Exim 
33% less performance than Postfix in some situations and will also make it 
less friendly to the network at large.
Comment 1 David Woodhouse 2006-09-28 01:41:22 EDT
See http://www.exim.org/exim-html-4.62/doc/html/spec_html/ch13.html#id2569429
for instructions on disabling all IPv6 support including AAAA lookups.

But yes, I agree that if we have no IPv6 support (in fact, I'd go so far as to
say if we have no non-link-local IPv6 addresses), Exim should probably do that
automatically.
Comment 2 Bug Zapper 2008-04-03 23:52:18 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.
http://fedoraproject.org/wiki/LifeCycle/EOL

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 3 Bug Zapper 2008-05-06 12:25:34 EDT
This bug is open for a Fedora version that is no longer maintained and
will not be fixed by Fedora. Therefore we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen thus bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Russell Coker 2008-05-06 20:53:54 EDT
Below is the tcpdump output from using a machine named "test" (which has the 
name "TEST" in tcpdump output) using a machine named "DNSSERVER" for it's DNS.  
I send myself an email, it does two "AAAA" lookups for itself (doing two 
lookups is a bug in itself) and then an "AAAA" lookup for my machine 
nospam.coker.com.au.  At the bottom of this report there is the ifconfig 
output showing that the machine in question has no IPv6 addresses and 
therefore no possibility of ever sending mail via IPv6.  I can only wonder 
what it might do if it was to get a response to one of it's AAAA requests.

This is from exim-4.68-1.fc8.

10:48:25.789466 IP TEST.filenet-nch > DNSSERVER.domain: 65297+ AAAA? test. 
(22)
10:48:25.790795 IP DNSSERVER.domain > TEST.filenet-nch: 65297 NXDomain 0/1/0 
(97)
10:48:25.822382 IP TEST.filenet-nch > DNSSERVER.domain: 37395+ AAAA? test. 
(22)
10:48:25.823566 IP DNSSERVER.domain > TEST.filenet-nch: 37395 NXDomain 0/1/0 
(97)
10:48:25.827032 IP TEST.filenet-nch > DNSSERVER.domain: 36442+ MX? 
coker.com.au. (30)
10:48:25.828610 IP DNSSERVER.domain > TEST.filenet-nch: 36442 1/2/3 MX[|
domain]
10:48:25.829319 IP TEST.filenet-nch > DNSSERVER.domain: 64716+ AAAA? 
nospam.sws.net.au. (35)
10:48:25.830459 IP DNSSERVER.domain > TEST.filenet-nch: 64716 0/1/0 (79)
10:48:25.831066 IP TEST.filenet-nch > DNSSERVER.domain: 4689+ A? 
nospam.sws.net.au. (35)
10:48:25.832517 IP DNSSERVER.domain > TEST.filenet-nch: 4689 1/2/2 A 
61.95.69.195 (132)

eth0      Link encap:Ethernet  HWaddr 00:02:A5:DE:52:B6
          inet addr:192.168.0.100  Bcast:192.168.0.255  Mask:255.255.255.0
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:386 errors:0 dropped:0 overruns:0 frame:0
          TX packets:312 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:37928 (37.0 KiB)  TX bytes:39671 (38.7 KiB)

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          UP LOOPBACK RUNNING  MTU:16436  Metric:1
          RX packets:1435 errors:0 dropped:0 overruns:0 frame:0
          TX packets:1435 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:3445452 (3.2 MiB)  TX bytes:3445452 (3.2 MiB)
Comment 6 Bug Zapper 2008-11-26 02:02:05 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2009-01-09 01:59:09 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.